@
@  Licensed Materials - Property of HCL
@  Restricted Material of HCL
@  HCL OneTest Embeded
@  (c) Copyright HCL Technologies Ltd. 2020.  All Rights Reserved.
@
@


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@   declare constant _ATC_CONST
@
    .if ATC_INFORMATION-2
    .if ATC_INFORMATION-1
    @ ATC_INFORMATION == 0 PASS MODE
    .equ    _ATC_CONST,0
    .else
    @ ATC_INFORMATION == 1 COMPACT MODE
    .equ    _ATC_CONST,2
    .endif
    .else
    @ ATC_INFORMATION == 2 COUNT MODE
    .equ    _ATC_CONST,4
    .endif


    .equ    _ATCPQ_RESET_COV,8
    .equ    _ATCPQ_RESET,_ATCPQ_RESET_COV


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@   macro ATC_PROC_IN
@

    .macro  ATC_PROC_IN table=1, bran=1
    push    {r0,lr}
    mov     r0,#\bran
    bl      local_atc_proc\table
ATC_PROC_\bran\():
    pop     {r0,lr}
    .endm  


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@   macro ATC_BLOC
@
    .macro  ATC_BLOC table=1, bran=1
    push    {r0,r1,lr}
    mov     r0,#\bran
    bl      local_atc_bloc\table
    pop     {r0,r1,lr}
    .endm  

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@   macro ATC_CALL
@
    .macro  ATC_CALL table=1, bran=1
    push    {r0,r1,lr}
    mov     r0,#\bran
    bl      local_atc_call\table
    pop     {r0,r1,lr}
    .endm  

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@   macro ATC_PROC_OUT
@
    .macro  ATC_PROC_OUT table=1, bran=1
    push    {r0,r1,lr}
    mov     r0,#\bran
    bl      local_atc_procend\table
    pop     {r0,r1,lr}
    .endm  


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@   macro _ATC_DECLARE_BLOC
@
    .macro _ATC_DECLARE_BLOC    table, nb_bran
    .data
    .local  atc_declare_bloc\table
    .if ATC_INFORMATION-2
    .if ATC_INFORMATION-1
    @ ATC_INFORMATION == 0 PASS MODE
    .comm   atc_declare_bloc\table,\nb_bran,4
    .else
    @ ATC_INFORMATION == 1 COMPACT MODE
    .comm   atc_declare_bloc\table,(7+\nb_bran)/8,4
    .endif
    .else
    @ ATC_INFORMATION == 2 COUNT MODE
    .comm   atc_declare_bloc\table,4*\nb_bran,4
    .endif
    .endm  

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@   macro _ATC_DECLARE_PROC
@
    .macro _ATC_DECLARE_PROC    table, nb_bran
    .data
    .local  atc_declare_proc\table
    .if ATC_INFORMATION-2
    .if ATC_INFORMATION-1
    @ ATC_INFORMATION == 0 PASS MODE
    .comm   atc_declare_proc\table,\nb_bran,4
    .else
    @ ATC_INFORMATION == 1 COMPACT MODE
    .comm   atc_declare_proc\table,(7+\nb_bran)/8,4
    .endif
    .else
    @ ATC_INFORMATION == 2 COUNT MODE
    .comm   atc_declare_proc\table,4*\nb_bran,4
    .endif

    .endm  



@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@   macro _ATC_DECLARE_CALL
@
    .macro _ATC_DECLARE_CALL    table, nb_bran
    .data
    .local  atc_declare_call\table
    .if ATC_INFORMATION-2
    .if ATC_INFORMATION-1
    @ ATC_INFORMATION == 0 PASS MODE
    .comm   atc_declare_call\table,\nb_bran,4
    .else
    @ ATC_INFORMATION == 1 COMPACT MODE
    .comm   atc_declare_call\table,(7+\nb_bran)/8,4
    .endif
    .else
    @ ATC_INFORMATION == 2 COUNT MODE
    .comm   atc_declare_call\table,4*\nb_bran,4
    .endif

    .endm  



@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@   macro _ATC_DECLARE_COND  (not used actualy)
@
    .macro _ATC_DECLARE_COND    table, nb_bran
    .data
    .local  atc_declare_cond\table
    .if ATC_INFORMATION-2
    .if ATC_INFORMATION-1
    @ ATC_INFORMATION == 0 PASS MODE
    .comm   atc_declare_cond\table,\nb_bran,4
    .else
    @ ATC_INFORMATION == 1 COMPACT MODE
    .comm   atc_declare_cond\table,(7+\nb_bran)/8,4
    .endif
    .else
    @ ATC_INFORMATION == 2 COUNT MODE
    .comm   atc_declare_cond\table,4*\nb_bran,4
    .endif

    .endm  



@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@   macro _ATC_DECLARE_BLOC_END  (not used now)
@
    .macro _ATC_DECLARE_BLOC_END    table
    .endm  
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@   macro _ATC_DECLARE_BLOC_ELEM  (not used now)
@
    .macro _ATC_DECLARE_BLOC_ELEM    num_bran
    .endm  


@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@   macro _ATCPQ_DUMP    
@
    .macro  _ATCPQ_DUMP reset_value
    push    {r0,lr}
    mov      r0,#\reset_value
@    bl      _atl_obstools_dump
    pop     {r0,lr}
    .endm



@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@   macro _ATL_END_EXEC
@
    .macro  _ATL_END_EXEC
    push    {lr}
    bl      atl_exit
    pop     {lr}
    .endm

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@   macro _ATC_DECLARE
@
    .macro _ATC_DECLARE table=1, key=0, checksum=0, nbproc=0 , tab_proc=0, nbcall=0, tab_call=0, nbbloc=0, tab_bloc=0, nbcond=0, tab_cond=0
    .equ    _ATC_TAB_PROC,atc_declare_proc\table
    .equ    _ATC_TAB_CALL,atc_declare_call\table
    .equ    _ATC_TAB_BLOC,atc_declare_bloc\table
    .equ    _ATC_TAB_COND,atc_declare_cond\table
    .data
_atc_data\table:
    .word   \key
    .word   \checksum
    .word   \nbproc
    .word   \nbcall
    .word   \nbbloc
    .word   \nbcond
    .word   \tab_proc
    .word   \tab_call
    .word   \tab_bloc
    .word   \tab_cond
    .word   0
    .byte   _ATC_CONST
    .space  3

@@@@@
@
@   declare some helper function
@
    .text
_atc_dataref\table:
    .word   _atc_data\table
_atc_declare_procref\table:
    .word   \tab_proc
_atc_declare_callref\table:
    .word   \tab_call
_atc_declare_blocref\table:
    .word   \tab_bloc
_atc_declare_condref\table:
    .word   \tab_cond

    
local_atc_proc\table:
    push    {r1,r2,r3,lr}
    mov     r1,r0
    MRS     r2,APSR
    ldr     r0,_atc_dataref\table
	bl  	_atc_link
    ldr     r0,_atc_declare_procref\table

    .if ATC_INFORMATION-2
    .if ATC_INFORMATION-1
    @ ATC_INFORMATION == 0 PASS MODE
    add     r0,r0,r1
    ldrb    r1,[r0]
    orr     r1,r1,#1
    strb    r1,[r0]    
    .else
    @ ATC_INFORMATION == 1 COMPACT MODE
    add     r0,r0,r1,LSR#3
    and     r1,r1,#7
    mov     r3,#1
    lsl     r3,r3,r1
    ldrb    r1,[r0]
    orr     r1,r1,r3
    strb    r1,[r0]    

    .endif
    .else
    @ ATC_INFORMATION == 2 COUNT MODE
    add     r0,r0,r1,LSL#2
    ldr     r1,[r0]
    adds     r1,r1,#1
    strne     r1,[r0]
    .endif


    MSR     APSR_nzcvq,r2
    pop    {r1,r2,r3,pc}

local_atc_bloc\table:
    ldr     r1,_atc_declare_blocref\table
local_atc_set:    
    .if ATC_INFORMATION-2
    .if ATC_INFORMATION-1
    @ ATC_INFORMATION == 0 PASS MODE
    add     r1,r1,r0
    ldrb    r0,[r1]
    orr     r0,r0,#1
    strb    r0,[r1]    
    .else
    @ ATC_INFORMATION == 1 COMPACT MODE
    push    {r2}
    add     r1,r1,r0,LSR#3
    and     r0,r0,#7
    mov     r2,#1
    lsl     r2,r2,r0
    ldrb    r0,[r1]
    orr     r0,r0,r2
    strb    r0,[r1]    
    pop     {r2}

    .endif
    .else
    @ ATC_INFORMATION == 2 COUNT MODE
    push    {r2}
    MRS     r2,APSR
    add     r1,r1,r0,LSL#2
    ldr     r0,[r1]
    adds     r0,r0,#1
    strne     r0,[r1]
    MSR     APSR_nzcvq,r2
    pop     {r2}
    .endif
    bx      lr

local_atc_call\table:
    ldr     r1,_atc_declare_callref\table
    b       local_atc_set

local_atc_procend\table:
    ldr     r1,_atc_declare_procref\table
    b       local_atc_set
    
    
    
    .endm


