

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2011 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* $Descr: Purify Header for Stack Management (included across TP.h) $
*******************************************************************************/


/* Multiple inclusions guard: */
#ifndef ATA_H_INCLUDED
#define ATA_H_INCLUDED


/*******************************************************************************
*  C/C++ Instrumentors
*******************************************************************************/

/*******************************************************************************
*  Parsing global data function management
*******************************************************************************/


/*******************************************************************************
*  C Instrumentor
*******************************************************************************/
#if ! RTRT_CPLUSPLUS_LANGUAGE
#define _ATL_DUMP_STACK(name) ata_dump_CALLSTACK(name,&_atl_stack_link);
#endif /* C language */

/*******************************************************************************
*  C++ Instrumentor
*******************************************************************************/
#if RTRT_CPLUSPLUS_LANGUAGE
#define _ATL_DUMP_STACK(name) ata_dump_CALLSTACK(name,&_atl_stack_object._atl_stack_link);
#endif /* C++ language */

/*******************************************************************************
* Library Allocation Functions:
*******************************************************************************/
#if !RTRT_KR

_ATL_EXTERN_C ATL_TP_PROTO_PREFIX     void ata_dump_CALLSTACK(const char *name, _AtlStackLinkP stack_link );
RTRT_STATICFCT void _ata_dump_uint( RTRT_U_INT32 v );
#if RTRT_64_BITS_PTR
RTRT_STATICFCT void _ata_dump_ptr( RTRT_INT_SIZE_PTR v );
#endif /* RTRT_64_BITS_PTR */
RTRT_STATICFCT void _ata_dump_start_test(void);
RTRT_STATICFCT void _ata_stack_dump( _AtlStackLinkP stack_link, int call_stack_size );

#else /* RTRT_KR */

_ATL_EXTERN_C ATL_TP_PROTO_PREFIX     void ata_dump_CALLSTACK  ( );
RTRT_STATICFCT void _ata_dump_uint( );
RTRT_STATICFCT void _ata_dump_ptr( );
RTRT_STATICFCT void _ata_dump_start_test();
RTRT_STATICFCT void _ata_stack_dump( );
#endif /* RTRT_KR */

#if RTRT_64_BITS_PTR
#define ata_dump_ptr(v) _ata_dump_ptr((RTRT_INT_SIZE_PTR)(v))
#else
#define ata_dump_ptr(v) _ata_dump_uint((RTRT_U_INT32)(v))
#endif /* RTRT_64_BITS_PTR */


#endif /* ATA_H_INCLUDED */
