

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2011 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* $Descr: QuantifyLT Header (included across TP.h) $
*******************************************************************************/


/* Multiple inclusions guard: */
#ifndef ATG_H_INCLUDED
#define ATG_H_INCLUDED

#define _ATG_INIT_FUNC(n) _atg_init_func
#define _ATG_INIT_DONE(n) _atg_init_done
#define _ATG_PATH_TABLE(n) 		  RTRT_CONCAT_MACRO(_atg_path_table,n) /* 1 path tabel per call EXT */
/* unique table whatever the number of source file */
#define _ATG_DATA(i)      _atg_data

/*******************************************************************************
*  C/C++ Instrumentor
*******************************************************************************/
#if ATL_DYN_TABLE
#if RTRT_HEAP != RTRT_NONE
#ifndef _ATG_ALLOC
#define _ATG_ALLOC(n,s) priv_malloc(n*s)
#define _ATG_FREE(p) priv_free(p)
#endif /* _ATG_ALLOC */


#define RTRT_ATG_DECLARE_OVERLOAD(i,s) \
static _atg_TP ATL_SET_MEM _ATG_DATA(i) ATL_SET_SECTION ; \
static unsigned char ATL_SET_MEM _ATG_INIT_DONE(i) ATL_SET_SECTION ATL_OBSTOOLS_INITIALIZE_TO_ZERO; \
static void _ATG_INIT_FUNC(i)(void)   { \
  if( RTRT_IS_NOT_INITIALIZED(_ATG_INIT_DONE(i))) \
  { \
    _ATG_INIT_DONE(i)=RTRT_VARIABLE_INITIALIZED; \
    _ATG_DATA(i)=(_atg_TP)_ATG_ALLOC(1,sizeof(_atg_T)); \
    _ATG_DATA(i)->Source=&RTRT_CONCAT_MACRO(_atl_source_struct,i); \
    _ATG_DATA(i)->NbPath=s; \
    _ATG_DATA(i)->DataSizeof=sizeof(atg_call_id_type); \
    _ATG_DATA(i)->Data=_ATG_ALLOC(s,sizeof(atg_call_id_type)); \
    _ATG_DATA(i)->Next=(_atg_TP)0; \
  } }

#define _ATG_INIT_CALL(i) _ATG_INIT_FUNC(i)(),

#ifndef _ATG_DATA_PTR
#define _ATG_DATA_PTR(i)           (_ATG_DATA(i))
//#define _ATG_DATA_TABLE(i)        _ATG_DATA(i)->Data
#endif /* _ATG_DATA_PTR */


#else /* RTRT_HEAP != RTRT_NONE */
#error "Dynamic table useless for TDP having RTRT_HEAP to NONE"
#endif /* RTRT_HEAP != RTRT_NONE */
#else /* ATL_DYN_TABLE */

#if !RTRT_VARIABLE_INIT_SUPPORTED

#define RTRT_ATG_DECLARE_OVERLOAD(i,s) \
static atg_call_id_type ATL_SET_MEM _atg_data_table[s] ATL_SET_SECTION; \
static _atg_T ATL_SET_MEM _ATG_DATA(i) ATL_SET_SECTION; \
static unsigned char ATL_SET_MEM _ATG_INIT_DONE(i) ATL_SET_SECTION ATL_OBSTOOLS_INITIALIZE_TO_ZERO; \
static void _ATG_INIT_FUNC(i)(void)   { \
  if( RTRT_IS_NOT_INITIALIZED(_ATG_INIT_DONE(i))) \
  { \
    _ATG_INIT_DONE(i)=RTRT_VARIABLE_INITIALIZED; \
    _ATG_DATA(i).Source=&RTRT_CONCAT_MACRO(_atl_source_struct,i); \
    _ATG_DATA(i).NbPath=s; \
    _ATG_DATA(i).DataSizeof=sizeof(atg_call_id_type); \
    _ATG_DATA(i).Data=(void*)(&_atg_data_table[0]); \
    _ATG_DATA(i).Next=(_atg_TP)0; \
  } }

#define _ATG_INIT_CALL(i) _ATG_INIT_FUNC(i)(),

#else /* RTRT_VARIABLE_INIT_SUPPORTED */

#define _ATG_INIT_CALL(i)

#endif /* RTRT_VARIABLE_INIT_SUPPORTED */
#endif /* ATL_DYN_TABLE */

typedef struct _atg_T_ {
        _AtlStackSourceP          Source;
        RTRT_U_INT16              NbPath;
        RTRT_U_INT8				  DataSizeof;
        void		             *Data;
        struct _atg_T_           *Next;
} _atg_T, *_atg_TP;


#ifndef _ATG_DATA_PTR
#define _ATG_DATA_PTR(i)           &(_ATG_DATA(i))
#endif /* _ATG_DATA_PTR */

#ifndef RTRT_ATG_DECLARE_OVERLOAD
/*_ATG_DECLARE(1,4)  Tsf_1 , nombre de longuest path Total 4 */
#define _ATG_DECLARE(i,s) \
static atg_call_id_type ATL_SET_MEM _atg_data_table[s] ATL_SET_SECTION; \
static _atg_T ATL_SET_MEM_CONST _ATG_DATA(i) ATL_SET_SECTION_CONST = { \
                               &RTRT_CONCAT_MACRO(_atl_source_struct,i), \
                               s, \
                               sizeof(atg_call_id_type), \
                               &_atg_data_table[0], \
                               (_atg_TP)0 \
                             };
#else /* RTRT_ATG_DECLARE_OVERLOAD */
#define _ATG_DECLARE(i,s) \
  RTRT_ATG_DECLARE_OVERLOAD(i,s)
#endif /* RTRT_ATG_DECLARE_OVERLOAD */

/* Path table declaration in source file */
#define _ATG_TYPE(type) \
	typedef RTRT_CONCAT_MACRO(RTRT_U_INT,type) atg_call_id_type;

#define _ATG_PATH_DECLARE(n,x) \
static const RTRT_U_INT16 _ATG_FIRST(n)=x; \
	static atg_call_id_type _ATG_PATH_TABLE(n)[]={

#define _ATG_PATH_IDX(x,l) l,
#define _ATG_PATH_END() \
	0}; /* 0 pour la longueur = fin de table */

#define _ATG_FIRST(n) RTRT_CONCAT_MACRO(_atg_first,n)

#define _ATG_IN(i)
#if !USE_ATZ
#define _ATZ_MEASURE()
#endif
/*******************************************************************************
*  C/C++ Instrumentor
*******************************************************************************/
#if RTRT_CPLUSPLUS_LANGUAGE
/* i is source number */
#define _ATG_CALL(o,n) \
  _ATZ_MEASURE() \
  _atl_stack_object._atl_stack_link.Info.CallId = n

#define _ATG_CALL_EXT(o,n) \
  _ATZ_MEASURE() \
  _atl_stack_object._atl_stack_link.Info.CallId = 0, \
  _ATG_INIT_CALL(0) \
  atg_set(&_atl_stack_object._atl_stack_link,(void*)(&_ATG_PATH_TABLE(n)[0]),_ATG_DATA_PTR(0),_ATG_FIRST(n))

#else /*RTRT_CPLUSPLUS_LANGUAGE*/
/* i is source number */
#define _ATG_CALL(o,n) \
  _ATZ_MEASURE() \
  _atl_stack_link.Info.CallId = n

#define _ATG_CALL_EXT(o,n) \
  _ATZ_MEASURE() \
  _atl_stack_link.Info.CallId = 0, \
  _ATG_INIT_CALL(0) \
  atg_set(&_atl_stack_link,(void*)(&_ATG_PATH_TABLE(n)[0]),_ATG_DATA_PTR(0),_ATG_FIRST(n))
#endif /*RTRT_CPLUSPLUS_LANGUAGE*/


/*******************************************************************************
* Functions prototypes:
*******************************************************************************/

#if !RTRT_KR

_ATL_EXTERN_C ATL_TP_PROTO_PREFIX void atg_set(_AtlStackLinkP,void *,_atg_TP,RTRT_U_INT16 );

#else /* RTRT_KR */

_ATL_EXTERN_C ATL_TP_PROTO_PREFIX void atg_set();
#endif /* RTRT_KR */

#endif /* ATG_H_INCLUDED */

