
/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2011 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* $Descr: QuantifyLT Header (included across TP.h) $
*******************************************************************************/


/* Multiple inclusions guard: */
#ifndef ATQ_H_INCLUDED
#define ATQ_H_INCLUDED

#ifndef _atq_T_count
#define _atq_T_count RTRT_U_INT32
#endif
#ifndef ATQ_COMPUTE_MINMAX
#ifdef ATQ_COMPUTE_WCET
#define ATQ_COMPUTE_MINMAX 1
#endif /* ATQ_COMPUTE_WCET */
#else /* ATQ_COMPUTE_MINMAX */
#if ATQ_COMPUTE_MINMAX > 1
#define ATQ_COMPUTE_WCET 1
#endif /*ATQ_COMPUTE_MINMAX > 1*/
#endif /* ATQ_COMPUTE_MINMAX */
/*******************************************************************************
*  C/C++ Instrumentor
*******************************************************************************/
#if ATL_DYN_TABLE
#if RTRT_HEAP != RTRT_NONE
#ifndef _ATQ_ALLOC
#define _ATQ_ALLOC(n,s) priv_malloc(n*s)
#define _ATQ_FREE(p) priv_free(p)
#endif /* _ATQ_ALLOC */

#if ATQ_COMPUTE_MINMAX
#define _ATQ_DATA_INIT_MINMAX(i,n) \
    _ATQ_DATA(i)->Tmin=(_atl_T_time*)_ATQ_ALLOC(n,sizeof(_atl_T_time)); \
    _ATQ_DATA(i)->Tmax=(_atl_T_time*)_ATQ_ALLOC(n,sizeof(_atl_T_time));
#if ATQ_COMPUTE_WCET
#if ATL_MULTI_THREADS
#define _ATQ_DECLAR_CALLCOUNT(i,c)
#define _ATQ_DECLAR_CALLCOUNT_STACK(i,c) _atq_T_count _ATQ_CALLCOUNT(i)[c];
#define _ATQ_DATA_INIT_CALLCOUNT(i,c)
#else /* ATL_MULTI_THREADS */
#define _ATQ_DECLAR_CALLCOUNT(i,c) static _atq_T_count* ATL_SET_MEM _ATQ_CALLCOUNT(i) ATL_SET_SECTION ;
#define _ATQ_DATA_INIT_CALLCOUNT(i,c) _ATQ_CALLCOUNT(i)=(_atq_T_count*)_ATQ_ALLOC(c,sizeof(_atq_T_count));
#endif /* ATL_MULTI_THREADS */
#define _ATQ_DATA_INIT_CALLOUT(i,c) \
    _ATQ_DATA(i)->NbCallOut=c; \
    _ATQ_DATA(i)->CallOut=(_atq_T_count*)_ATQ_ALLOC(c,sizeof(_atq_T_count)); \
	_ATQ_DATA_INIT_CALLCOUNT(i,c) 
/* when CallOUT table is declared into HEAP, MAX are accesible from atq structure but counters are separate */
#define _ATQ_CALLOUT_MAX(i,x)    _ATQ_DATA(i)->CallOut[x]
#define _ATQ_CALLOUT_COUNTER(i,x) (_ATQ_CALLCOUNT(i)[x])


#else /* ATQ_COMPUTE_WCET */
#define _ATQ_DECLAR_CALLCOUNT(i,c)
#define _ATQ_DECLAR_CALLCOUNT_STACK(i,c)
#define _ATQ_DATA_INIT_CALLOUT(i,c)
#endif /* ATQ_COMPUTE_WCET */
#else /* ATQ_COMPUTE_MINMAX */
#define _ATQ_DATA_INIT_MINMAX(i,n)
#define _ATQ_DECLAR_CALLCOUNT(i,c)
#define _ATQ_DECLAR_CALLCOUNT_STACK(i,c)
#define _ATQ_DATA_INIT_CALLOUT(i,c)
#endif /* ATQ_COMPUTE_MINMAX */
#define ATQ_DECLARE_MINMAX(i,n)
#define ATQ_SET_MINMAX(i)

#define _ATQ_INIT_FUNC(i) RTRT_CONCAT_MACRO(_atq_init_func,i)
#define _ATQ_INIT_DONE(i) RTRT_CONCAT_MACRO(_atq_init_done,i)

#define RTRT_ATQ_DECLARE_OVERLOAD_CALLS(i,n,c) \
static _atq_TP ATL_SET_MEM _ATQ_DATA(i) ATL_SET_SECTION ; \
static unsigned char ATL_SET_MEM _ATQ_INIT_DONE(i) ATL_SET_SECTION ATL_OBSTOOLS_INITIALIZE_TO_ZERO; \
_ATQ_DECLAR_CALLCOUNT(i,c) \
static void _ATQ_INIT_FUNC(i)(void)   { \
  if( RTRT_IS_NOT_INITIALIZED(_ATQ_INIT_DONE(i))) \
  { \
    _ATQ_INIT_DONE(i)=RTRT_VARIABLE_INITIALIZED; \
    _ATQ_DATA(i)=(_atq_TP)_ATQ_ALLOC(1,sizeof(_atq_T)); \
    _ATQ_DATA(i)->Key=0; \
    _ATQ_DATA(i)->CheckSum=0; \
    _ATQ_DATA(i)->Routines=n; \
    _ATQ_DATA(i)->Calls=(_atq_T_count*)_ATQ_ALLOC(n,sizeof(_atq_T_count)); \
    _ATQ_DATA(i)->Local=(_atl_T_time*)_ATQ_ALLOC(n,sizeof(_atl_T_time)); \
    _ATQ_DATA(i)->Total=(_atl_T_time*)_ATQ_ALLOC(n,sizeof(_atl_T_time)); \
    _ATQ_DATA_INIT_MINMAX(i,n) \
    _ATQ_DATA_INIT_CALLOUT(i,c) \
    _ATQ_DATA(i)->Next=(_atq_TP)0; \
  } }

#define RTRT_ATQ_DECLARE_OVERLOAD(i,n) RTRT_ATQ_DECLARE_OVERLOAD_CALLS(i,n,0)
#define _ATQ_INIT_CALL(i) _ATQ_INIT_FUNC(i)();

#ifndef _ATQ_DATA_PTR
#define _ATQ_CALLS_TABLE(i)        _ATQ_DATA(i)->Calls
#define _ATQ_LOCAL_TABLE(i)        _ATQ_DATA(i)->Local
#define _ATQ_TOTAL_TABLE(i)        _ATQ_DATA(i)->Total
#define _ATQ_TMIN_TABLE(i)         _ATQ_DATA(i)->Tmin
#define _ATQ_TMAX_TABLE(i)         _ATQ_DATA(i)->Tmax
#define _ATQ_CALLOUT_TABLE(i)      _ATQ_DATA(i)->CallOut
#define _ATQ_CALLCOUNT(i)          RTRT_CONCAT_MACRO(_atq_callCount_table,i)
#define _ATQ_DATA_PTR(i)           (_ATQ_DATA(i))
#endif /* _ATQ_DATA_PTR */


#else /* RTRT_HEAP != RTRT_NONE */
#error "Dynamic table useless for TDP having RTRT_HEAP to NONE"
#endif /* RTRT_HEAP != RTRT_NONE */
#else /* ATL_DYN_TABLE */

#if ATQ_COMPUTE_MINMAX
#define ATQ_DECLARE_MINMAX(i,n) \
static _atl_T_time ATL_SET_MEM _ATQ_TMIN_TABLE(i)[n] ATL_SET_SECTION; \
static _atl_T_time ATL_SET_MEM _ATQ_TMAX_TABLE(i)[n] ATL_SET_SECTION;
#define ATQ_SET_MINMAX(i) \
   &_ATQ_TMIN_TABLE(i)[0], \
   &_ATQ_TMAX_TABLE(i)[0],

#define _ATQ_DATA_INIT_MINMAX(i,n) \
    _ATQ_DATA(i).Tmin=&_ATQ_TMIN_TABLE(i)[0]; \
    _ATQ_DATA(i).Tmax=&_ATQ_TMAX_TABLE(i)[0];
	
#if ATQ_COMPUTE_WCET
#if ATL_MULTI_THREADS
#define _ATQ_DECLAR_CALLCOUNT(i,c)
#define _ATQ_DECLAR_CALLCOUNT_STACK(i,c) _atq_T_count _ATQ_CALLCOUNT(i)[c];
#else /* ATL_MULTI_THREADS */
#define _ATQ_DECLAR_CALLCOUNT(i,c) static _atq_T_count ATL_SET_MEM _ATQ_CALLCOUNT(i)[c] ATL_SET_SECTION ;
#endif /* ATL_MULTI_THREADS */

#define ATQ_DECLARE_CALLOUT(i,c) \
_ATQ_DECLAR_CALLCOUNT(i,c) \
static _atq_T_count ATL_SET_MEM _ATQ_CALLOUT_TABLE(i)[c] ATL_SET_SECTION;
#define _ATQ_CALLOUT_MAX(i,x)    _ATQ_CALLOUT_TABLE(i)[x]
#define _ATQ_CALLOUT_COUNTER(i,x) (_ATQ_CALLCOUNT(i)[x])
#define ATQ_SET_CALLOUT(i,c) \
   c, \
   &_ATQ_CALLOUT_TABLE(i)[0],
#define ATQ_SET_NOCALLOUT(i) 0,(_atq_T_count*)0,
#define _ATQ_DATA_INIT_NOCALLOUT(i) \
    _ATQ_DATA(i).NbCallOut=0; \
    _ATQ_DATA(i).CallOut=(_atq_T_count*)0;
#define _ATQ_DATA_INIT_CALLOUT(i,c) \
    _ATQ_DATA(i).NbCallOut=c; \
    _ATQ_DATA(i).CallOut=&_ATQ_CALLOUT_TABLE(i)[0];
#else /* ATQ_COMPUTE_WCET */
#define _ATQ_DATA_INIT_CALLOUT(i,c)
#define ATQ_DECLARE_CALLOUT(i,c)
#define _ATQ_DECLAR_CALLCOUNT_STACK(i,c)
#define ATQ_SET_CALLOUT(i,c)
#define ATQ_SET_NOCALLOUT(i)
#define _ATQ_DATA_INIT_NOCALLOUT(i) 
#endif /* ATQ_COMPUTE_WCET */
#else /* ATQ_COMPUTE_MINMAX */
#define ATQ_DECLARE_MINMAX(i,n)
#define ATQ_SET_MINMAX(i)
#define _ATQ_DATA_INIT_MINMAX(i,n)
#define ATQ_DECLARE_CALLOUT(i,c)
#define _ATQ_DECLAR_CALLCOUNT_STACK(i,c)
#define ATQ_SET_CALLOUT(i,c)
#define ATQ_SET_NOCALLOUT(i)
#define _ATQ_DATA_INIT_NOCALLOUT(i) 
#define _ATQ_DATA_INIT_CALLOUT(i,c)
#endif /* ATQ_COMPUTE_MINMAX */

#if !RTRT_VARIABLE_INIT_SUPPORTED

#define _ATQ_INIT_FUNC(i) RTRT_CONCAT_MACRO(_atq_init_func,i)
#define _ATQ_INIT_DONE(i) RTRT_CONCAT_MACRO(_atq_init_done,i)

#define RTRT_ATQ_DECLARE_OVERLOAD_CALLS(i,n,c) \
static _atq_T_count ATL_SET_MEM _ATQ_CALLS_TABLE(i)[n] ATL_SET_SECTION; \
static _atl_T_time ATL_SET_MEM _ATQ_LOCAL_TABLE(i)[n] ATL_SET_SECTION; \
static _atl_T_time ATL_SET_MEM _ATQ_TOTAL_TABLE(i)[n] ATL_SET_SECTION; \
ATQ_DECLARE_MINMAX(i,n) \
ATQ_DECLARE_CALLOUT(i,c) \
static _atq_T ATL_SET_MEM _ATQ_DATA(i) ATL_SET_SECTION; \
static unsigned char ATL_SET_MEM _ATQ_INIT_DONE(i) ATL_SET_SECTION ATL_OBSTOOLS_INITIALIZE_TO_ZERO; \
static void _ATQ_INIT_FUNC(i)(void)   { \
  if( RTRT_IS_NOT_INITIALIZED(_ATQ_INIT_DONE(i))) \
  { \
    _ATQ_INIT_DONE(i)=RTRT_VARIABLE_INITIALIZED; \
    _ATQ_DATA(i).Source=(_AtlStackSourceP)0; \
    _ATQ_DATA(i).Routines=n; \
    _ATQ_DATA(i).Calls=&_ATQ_CALLS_TABLE(i)[0]; \
    _ATQ_DATA(i).Local=&_ATQ_LOCAL_TABLE(i)[0]; \
    _ATQ_DATA(i).Total=&_ATQ_TOTAL_TABLE(i)[0]; \
    _ATQ_DATA_INIT_MINMAX(i,n) \
    _ATQ_DATA_INIT_CALLOUT(i,c) \
    _ATQ_DATA(i).Next=(_atq_TP)0; \
  } }

#define RTRT_ATQ_DECLARE_OVERLOAD(i,n) \
static _atq_T_count ATL_SET_MEM _ATQ_CALLS_TABLE(i)[n] ATL_SET_SECTION; \
static _atl_T_time ATL_SET_MEM _ATQ_LOCAL_TABLE(i)[n] ATL_SET_SECTION; \
static _atl_T_time ATL_SET_MEM _ATQ_TOTAL_TABLE(i)[n] ATL_SET_SECTION; \
ATQ_DECLARE_MINMAX(i,n) \
static _atq_T ATL_SET_MEM _ATQ_DATA(i) ATL_SET_SECTION; \
static unsigned char ATL_SET_MEM _ATQ_INIT_DONE(i) ATL_SET_SECTION ATL_OBSTOOLS_INITIALIZE_TO_ZERO; \
static void _ATQ_INIT_FUNC(i)(void)   { \
  if( RTRT_IS_NOT_INITIALIZED(_ATQ_INIT_DONE(i))) \
  { \
    _ATQ_INIT_DONE(i)=RTRT_VARIABLE_INITIALIZED; \
    _ATQ_DATA(i).Source=(_AtlStackSourceP)0; \
    _ATQ_DATA(i).Routines=n; \
    _ATQ_DATA(i).Calls=&_ATQ_CALLS_TABLE(i)[0]; \
    _ATQ_DATA(i).Local=&_ATQ_LOCAL_TABLE(i)[0]; \
    _ATQ_DATA(i).Total=&_ATQ_TOTAL_TABLE(i)[0]; \
    _ATQ_DATA_INIT_MINMAX(i,n) \
    _ATQ_DATA_INIT_NOCALLOUT(i,c) \
    _ATQ_DATA(i).Next=(_atq_TP)0; \
  } }

#define _ATQ_INIT_CALL(i) _ATQ_INIT_FUNC(i)();

#else /* RTRT_VARIABLE_INIT_SUPPORTED */

#define _ATQ_INIT_CALL(i)

#endif /* RTRT_VARIABLE_INIT_SUPPORTED */
#endif /* ATL_DYN_TABLE */

typedef struct _atq_T_ {
#if ATL_DYN_TABLE
        RTRT_U_INT32              Key;
        RTRT_U_INT32              CheckSum;
#else /* ATL_DYN_TABLE */
        _AtlStackSourceP              Source;
#endif /* ATL_DYN_TABLE */
        _atq_T_count                  Routines;
        _atq_T_count                 *Calls;
        _atl_T_time                  *Local;
        _atl_T_time                  *Total;
#if ATQ_COMPUTE_MINMAX
        _atl_T_time                  *Tmin;
		_atl_T_time                  *Tmax;
#if ATQ_COMPUTE_WCET
        _atq_T_count                 NbCallOut;
        _atq_T_count                 *CallOut;
#endif
#endif
        struct _atq_T_               *Next;
} _atq_T, *_atq_TP;

#define _ATQ_DATA(i)               RTRT_CONCAT_MACRO(_atq_data,i)

#ifndef _ATQ_DATA_PTR
#define _ATQ_CALLS_TABLE(i)        RTRT_CONCAT_MACRO(_atq_calls_table,i)
#define _ATQ_LOCAL_TABLE(i)        RTRT_CONCAT_MACRO(_atq_local_table,i)
#define _ATQ_TOTAL_TABLE(i)        RTRT_CONCAT_MACRO(_atq_total_table,i)
#define _ATQ_TMIN_TABLE(i)         RTRT_CONCAT_MACRO(_atq_tmin_table,i)
#define _ATQ_TMAX_TABLE(i)         RTRT_CONCAT_MACRO(_atq_tmax_table,i)
#define _ATQ_CALLOUT_TABLE(i)      RTRT_CONCAT_MACRO(_atq_callout_table,i)
#define _ATQ_CALLCOUNT(i)          RTRT_CONCAT_MACRO(_atq_callCount_table,i)
#define _ATQ_DATA_PTR(i)           &(_ATQ_DATA(i))
#endif /* _ATQ_DATA_PTR */

#ifndef RTRT_ATQ_DECLARE_OVERLOAD
#define _ATQ_DECLARE(i,n) \
static _atq_T_count ATL_SET_MEM _ATQ_CALLS_TABLE(i)[n] ATL_SET_SECTION; \
static _atl_T_time  ATL_SET_MEM _ATQ_LOCAL_TABLE(i)[n] ATL_SET_SECTION; \
static _atl_T_time  ATL_SET_MEM _ATQ_TOTAL_TABLE(i)[n] ATL_SET_SECTION; \
ATQ_DECLARE_MINMAX(i,n) \
static _atq_T ATL_SET_MEM_CONST _ATQ_DATA(i) ATL_SET_SECTION_CONST = { \
                               (_AtlStackSourceP)0, \
                               n, \
                               &_ATQ_CALLS_TABLE(i)[0], \
                               &_ATQ_LOCAL_TABLE(i)[0], \
                               &_ATQ_TOTAL_TABLE(i)[0], \
                               ATQ_SET_MINMAX(i) \
                               ATQ_SET_NOCALLOUT(i) \
                               (_atq_TP)0 \
                             };

#define _ATQ_DECLARE_WITH_CALLS(i,n,c) \
static _atq_T_count ATL_SET_MEM _ATQ_CALLS_TABLE(i)[n] ATL_SET_SECTION; \
static _atl_T_time  ATL_SET_MEM _ATQ_LOCAL_TABLE(i)[n] ATL_SET_SECTION; \
static _atl_T_time  ATL_SET_MEM _ATQ_TOTAL_TABLE(i)[n] ATL_SET_SECTION; \
ATQ_DECLARE_MINMAX(i,n) \
ATQ_DECLARE_CALLOUT(i,c) \
static _atq_T ATL_SET_MEM_CONST _ATQ_DATA(i) ATL_SET_SECTION_CONST = { \
                               (_AtlStackSourceP)0, \
                               n, \
                               &_ATQ_CALLS_TABLE(i)[0], \
                               &_ATQ_LOCAL_TABLE(i)[0], \
                               &_ATQ_TOTAL_TABLE(i)[0], \
                               ATQ_SET_MINMAX(i) \
                               ATQ_SET_CALLOUT(i,c) \
                               (_atq_TP)0 \
                             };

#else /* RTRT_ATQ_DECLARE_OVERLOAD */

#define _ATQ_DECLARE(i,n) \
  RTRT_ATQ_DECLARE_OVERLOAD(i,n)
/* c is the number of calls found in the source i */
#define _ATQ_DECLARE_WITH_CALLS(i,n,c) \
  RTRT_ATQ_DECLARE_OVERLOAD_CALLS(i,n,c)
  
#endif /* RTRT_ATQ_DECLARE_OVERLOAD */


/*******************************************************************************
*  C/C++ Instrumentor
*******************************************************************************/
/* _ATQ_CALL is available for both C/C++
   i=#tsf x=call ID 
   c=call ID of the first call in the method 
   c is used in multi-thread when counters are declared in stack by _ATL_STACK_IN3()
   instead of static by _ATQ_DECLARE_WITH_CALLS() 
   _ATQ_CALL is supposed to call _ATZ_CALL if USE_ATZ && !USE_ATG */

#if USE_ATZ && !USE_ATG
#if ATQ_COMPUTE_WCET
#if ATL_MULTI_THREADS 
#define _ATQ_CALL(i,x,c) _atq_callout(++_ATQ_CALLOUT_COUNTER(i,x-c),&_ATQ_CALLOUT_MAX(i,x)) ,_ATZ_CALL(0,x)
#else /* ATL_MULTI_THREADS */
#define _ATQ_CALL(i,x,c) _atq_callout(++_ATQ_CALLOUT_COUNTER(i,x),&_ATQ_CALLOUT_MAX(i,x)) ,_ATZ_CALL(0,x)
#endif /* ATL_MULTI_THREADS */
#else /* ATQ_COMPUTE_WCET */
#define _ATQ_CALL(i,x,c) _ATZ_CALL(0,x)
#endif /* ATQ_COMPUTE_WCET */
#else /* USE_ATZ && !USE_ATG*/
#if ATQ_COMPUTE_WCET
#if ATL_MULTI_THREADS 
#define _ATQ_CALL(i,x,c) _atq_callout(++_ATQ_CALLOUT_COUNTER(i,x-c),&_ATQ_CALLOUT_MAX(i,x))
#else /* ATL_MULTI_THREADS */
#define _ATQ_CALL(i,x,c) _atq_callout(++_ATQ_CALLOUT_COUNTER(i,x),&_ATQ_CALLOUT_MAX(i,x))
#endif /* ATL_MULTI_THREADS */
#else /* ATQ_COMPUTE_WCET */
#define _ATQ_CALL(i,x,c) 0
#endif /* ATQ_COMPUTE_WCET */
#endif /* USE_ATZ && !USE_ATG*/

#if ATQ_COMPUTE_WCET

#if ATL_MULTI_THREADS 
#define _ATQ_CALLCLEAN(i,x,len) _atq_callclean(&_ATQ_CALLOUT_COUNTER(i,0),len);
#else /* ATL_MULTI_THREADS */
#define _ATQ_CALLCLEAN(i,x,len) _atq_callclean(&_ATQ_CALLOUT_COUNTER(i,x),len);
#endif /* ATL_MULTI_THREADS */
#else /* ATQ_COMPUTE_WCET */
#define _ATQ_CALLCLEAN(i,x,len)
#endif /* ATQ_COMPUTE_WCET */

#if ! RTRT_CPLUSPLUS_LANGUAGE

/* i is source number */
#define _ATQ_IN(i) \
  _ATQ_INIT_CALL(i) \
  _atl_stack_link.AtqData = (void *)(_ATQ_DATA_PTR(i)); \
  _atq_start(&_atl_stack_link);

/* i is source number */
#define _ATQ_OUT \
  _atq_end(&_atl_stack_link);

/* i is source number */
#define _ATQ_OUT_EXPR \
  _atq_end(&_atl_stack_link)

#endif /* C language */



/*******************************************************************************
*  C++ Instrumentor
*******************************************************************************/
#if RTRT_CPLUSPLUS_LANGUAGE

/* i is source number */
#define _ATQ_DEFINE_CLASS_IN(i) \
class _ATQ_CLASS_IN(i) { \
  public : \
    _AtlStackLinkP StackLink; \
    _ATQ_CLASS_IN(i) (_AtlStackLinkP _atl_stack_link) \
    { StackLink = _atl_stack_link; \
      _ATQ_INIT_CALL(i) \
      StackLink->AtqData = (void *)(_ATQ_DATA_PTR(i)); \
      _atq_start ( StackLink ); } \
    ~_ATQ_CLASS_IN(i) () \
    { _atq_end(StackLink); } \
    _ATL_ANOTHER_METHOD \
};

#define _ATQ_IN(i) \
  _ATQ_CLASS_IN(i) _atq_object(&(_atl_stack_object._atl_stack_link)); \
  _ATL_ANOTHER_METHOD_CALL(_atq_object)

#endif /* C++ language */

#define _ATQ_IN3(i,x,len) \
  _ATQ_IN(i) _ATQ_CALLCLEAN(i,x,len)


/*******************************************************************************
* Functions prototypes:
*******************************************************************************/

#if !RTRT_KR

_ATL_EXTERN_C     void _atq_dump              ( int );
_ATL_EXTERN_C  ATL_TP_PROTO_PREFIX   void _atq_start             ( _AtlStackLinkP );
_ATL_EXTERN_C  ATL_TP_PROTO_PREFIX   int  _atq_end               ( _AtlStackLinkP );
_ATL_EXTERN_C  ATL_TP_PROTO_PREFIX   void _atq_callout           (_atq_T_count , _atq_T_count*);
_ATL_EXTERN_C  ATL_TP_PROTO_PREFIX   void _atq_callclean         (_atq_T_count*,int);

_ATL_EXTERN_C  ATL_TP_PROTO_PREFIX   void atq_early_init         ( void );
_ATL_EXTERN_C  ATL_TP_PROTO_PREFIX   void atq_early_init         ( void );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void atq_late_exit          ( void );

_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void _atq_schedule_hook (RTRT_THIDX_T , RTRT_THIDX_T  );

#else /* RTRT_KR */

_ATL_EXTERN_C     void _atq_dump              ( );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void _atq_start             ( );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    int  _atq_end               ( );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void atq_early_init         ( );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void atq_late_exit          ( );
_ATL_EXTERN_C ATL_TP_PROTO_PREFIX    void _atq_schedule_hook     ( );
_ATL_EXTERN_C  ATL_TP_PROTO_PREFIX   void _atq_callout           ( );
_ATL_EXTERN_C  ATL_TP_PROTO_PREFIX   void _atq_callclean         ( );

#endif /* RTRT_KR */

#endif /* ATQ_H_INCLUDED */

